<?php

class myUser extends sfBasicSecurityUser
{
	public function signOut(){
		$this->getAttributeHolder()->removeNamespace('athlete');
		$this->clearCredentials();
		$this->setAuthenticated(false);
	}

	public function signIn($user)
	{

		$this->setAuthenticated(true);
		$this->setAttribute('nickname', $user->getNickname(), 'athlete');
		$this->setAttribute('user_id', $user->getId(), 'athlete');

		//check if the user is an admin
		if($user->getIsAdmin()){
			$this->addCredential('is_admin');
			$this->setAttribute('is_admin', $user->getIsAdmin(), 'athlete');
		}
		else{
			$this->setAttribute('is_admin', $user->getIsAdmin(), 'athlete');
		}

		//check if the user is a coach
		if($user->getIsCoach()){
			$this->addCredential('is_coach');
			$this->setAttribute('is_coach', $user->getIsCoach(), 'athlete');
		}
		else{
			$this->setAttribute('is_coach', $user->getIsCoach(), 'athlete');
		}

		//check if the user is an athlete
		if($user->getIsAthlete()){
			$this->addCredential('is_athlete');
			$this->setAttribute('is_athlete', $user->getIsAthlete(), 'athlete');
		}
		else{
			$this->setAttribute('is_athlete', $user->getIsAthlete(), 'athlete');
		}
		if($user->getCulture()!=null){
			$this->setCulture($user->getCulture());
		}
	}

	public function getAthleteId() {
		return $this->getAttribute('user_id', '', 'athlete');
	}


	public function getAthlete()
	{
		return UserPeer::retrieveByPk($this->getAthleteId());
	}

	public function getNickname()
	{
		return $this->getAttribute('nickname', '', 'athlete');
	}

	public function getIsAdmin()
	{
		return $this->getAttribute('is_admin', '', 'athlete');
	}

	public function getIsAthlete()
	{
		return $this->getAttribute('is_athlete', '', 'athlete');
	}

	public function getIsCoach()
	{
		return $this->getAttribute('is_coach', '', 'athlete');
	}

}
