<?php



class CircuitMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.CircuitMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('circuit');
		$tMap->setPhpName('Circuit');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('DISTANCE', 'Distance', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addForeignKey('EVENT_ID', 'EventId', 'int', CreoleTypes::INTEGER, 'event', 'ID', false, null);

		$tMap->addColumn('FIRST_NUMBER', 'FirstNumber', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('LAST_NUMBER', 'LastNumber', 'int', CreoleTypes::INTEGER, false, null);

	} 
} 