<?php



class ElementFeedbackMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.ElementFeedbackMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('element_feedback');
		$tMap->setPhpName('ElementFeedback');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::VARCHAR, false, 250);

		$tMap->addColumn('QUANTITY', 'Quantity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addForeignKey('FEEDBACK_TYPE_ID', 'FeedbackTypeId', 'int', CreoleTypes::INTEGER, 'feedback_type', 'ID', false, null);

		$tMap->addForeignKey('UNIT_ID', 'UnitId', 'int', CreoleTypes::INTEGER, 'unit', 'ID', false, null);

		$tMap->addForeignKey('SESSION_ELEMENT_ID', 'SessionElementId', 'int', CreoleTypes::INTEGER, 'session_element', 'ID', false, null);

		$tMap->addColumn('PENDING', 'Pending', 'boolean', CreoleTypes::BOOLEAN, false, null);

	} 
} 