<?php



class RunnerMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.RunnerMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('runner');
		$tMap->setPhpName('Runner');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('NAME', 'Name', 'string', CreoleTypes::VARCHAR, true, 100);

		$tMap->addColumn('SURNAME', 'Surname', 'string', CreoleTypes::VARCHAR, true, 250);

		$tMap->addColumn('NIF', 'Nif', 'string', CreoleTypes::VARCHAR, false, 13);

		$tMap->addColumn('EMAIL', 'Email', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('ADDRESS', 'Address', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('POSTAL_CODE', 'PostalCode', 'string', CreoleTypes::VARCHAR, false, 10);

		$tMap->addColumn('CITY', 'City', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('REGION', 'Region', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('COUNTRY', 'Country', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('BORN_AT', 'BornAt', 'string', CreoleTypes::VARCHAR, true, null);

		$tMap->addColumn('MALE', 'Male', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('CLUB', 'Club', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addForeignKey('SIZE_ID', 'SizeId', 'int', CreoleTypes::INTEGER, 'size', 'ID', false, null);

		$tMap->addColumn('FEDERATED', 'Federated', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('LICENCE_NUMBER', 'LicenceNumber', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('SPORT', 'Sport', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('TELEPHONE', 'Telephone', 'string', CreoleTypes::VARCHAR, false, 12);

		$tMap->addColumn('NO_COMPETITIVE', 'NoCompetitive', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('PRICE', 'Price', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addForeignKey('INSCRIPTION_ID', 'InscriptionId', 'int', CreoleTypes::INTEGER, 'inscription', 'ID', false, null);

		$tMap->addForeignKey('CATEGORY_ID', 'CategoryId', 'int', CreoleTypes::INTEGER, 'category', 'ID', false, null);

		$tMap->addColumn('NUMBER', 'Number', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'int', CreoleTypes::DATE, false, null);

	} 
} 