<?php



class SessionMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SessionMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('session');
		$tMap->setPhpName('Session');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DATE', 'Date', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('MORNING_SESSION', 'MorningSession', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('FEEDBACK', 'Feedback', 'string', CreoleTypes::VARCHAR, false, 250);

		$tMap->addForeignKey('MICROCYCLE_ID', 'MicrocycleId', 'int', CreoleTypes::INTEGER, 'microcycle', 'ID', false, null);

		$tMap->addColumn('WAKE_UP_HR', 'WakeUpHr', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_INTENSITY', 'TheoricIntensity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_VOLUME', 'TheoricVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY', 'ReportedIntensity', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_VOLUME', 'ReportedVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('L_CCL', 'LCcl', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('CCL', 'Ccl', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('CCM', 'Ccm', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('UAM', 'Uam', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('M_UAM', 'MUam', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('LACT1', 'Lact1', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('LACT2', 'Lact2', 'double', CreoleTypes::DOUBLE, false, null);

	} 
} 