<?php


abstract class BaseElementFeedback extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $quantity;


	
	protected $feedback_type_id;


	
	protected $unit_id;


	
	protected $session_element_id;


	
	protected $pending;

	
	protected $aFeedbackType;

	
	protected $aUnit;

	
	protected $aSessionElement;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getQuantity()
	{

		return $this->quantity;
	}

	
	public function getFeedbackTypeId()
	{

		return $this->feedback_type_id;
	}

	
	public function getUnitId()
	{

		return $this->unit_id;
	}

	
	public function getSessionElementId()
	{

		return $this->session_element_id;
	}

	
	public function getPending()
	{

		return $this->pending;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::DESCRIPTION;
		}

	} 
	
	public function setQuantity($v)
	{

		if ($this->quantity !== $v) {
			$this->quantity = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::QUANTITY;
		}

	} 
	
	public function setFeedbackTypeId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->feedback_type_id !== $v) {
			$this->feedback_type_id = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::FEEDBACK_TYPE_ID;
		}

		if ($this->aFeedbackType !== null && $this->aFeedbackType->getId() !== $v) {
			$this->aFeedbackType = null;
		}

	} 
	
	public function setUnitId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->unit_id !== $v) {
			$this->unit_id = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::UNIT_ID;
		}

		if ($this->aUnit !== null && $this->aUnit->getId() !== $v) {
			$this->aUnit = null;
		}

	} 
	
	public function setSessionElementId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->session_element_id !== $v) {
			$this->session_element_id = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::SESSION_ELEMENT_ID;
		}

		if ($this->aSessionElement !== null && $this->aSessionElement->getId() !== $v) {
			$this->aSessionElement = null;
		}

	} 
	
	public function setPending($v)
	{

		if ($this->pending !== $v) {
			$this->pending = $v;
			$this->modifiedColumns[] = ElementFeedbackPeer::PENDING;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->quantity = $rs->getFloat($startcol + 2);

			$this->feedback_type_id = $rs->getInt($startcol + 3);

			$this->unit_id = $rs->getInt($startcol + 4);

			$this->session_element_id = $rs->getInt($startcol + 5);

			$this->pending = $rs->getBoolean($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ElementFeedback object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ElementFeedbackPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ElementFeedbackPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ElementFeedbackPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aFeedbackType !== null) {
				if ($this->aFeedbackType->isModified() || $this->aFeedbackType->getCurrentFeedbackTypeI18N()->isModified()) {
					$affectedRows += $this->aFeedbackType->save($con);
				}
				$this->setFeedbackType($this->aFeedbackType);
			}

			if ($this->aUnit !== null) {
				if ($this->aUnit->isModified() || $this->aUnit->getCurrentUnitI18N()->isModified()) {
					$affectedRows += $this->aUnit->save($con);
				}
				$this->setUnit($this->aUnit);
			}

			if ($this->aSessionElement !== null) {
				if ($this->aSessionElement->isModified()) {
					$affectedRows += $this->aSessionElement->save($con);
				}
				$this->setSessionElement($this->aSessionElement);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ElementFeedbackPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ElementFeedbackPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aFeedbackType !== null) {
				if (!$this->aFeedbackType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aFeedbackType->getValidationFailures());
				}
			}

			if ($this->aUnit !== null) {
				if (!$this->aUnit->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnit->getValidationFailures());
				}
			}

			if ($this->aSessionElement !== null) {
				if (!$this->aSessionElement->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSessionElement->getValidationFailures());
				}
			}


			if (($retval = ElementFeedbackPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ElementFeedbackPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getQuantity();
				break;
			case 3:
				return $this->getFeedbackTypeId();
				break;
			case 4:
				return $this->getUnitId();
				break;
			case 5:
				return $this->getSessionElementId();
				break;
			case 6:
				return $this->getPending();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ElementFeedbackPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getQuantity(),
			$keys[3] => $this->getFeedbackTypeId(),
			$keys[4] => $this->getUnitId(),
			$keys[5] => $this->getSessionElementId(),
			$keys[6] => $this->getPending(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ElementFeedbackPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setQuantity($value);
				break;
			case 3:
				$this->setFeedbackTypeId($value);
				break;
			case 4:
				$this->setUnitId($value);
				break;
			case 5:
				$this->setSessionElementId($value);
				break;
			case 6:
				$this->setPending($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ElementFeedbackPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setQuantity($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFeedbackTypeId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setUnitId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setSessionElementId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setPending($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ElementFeedbackPeer::DATABASE_NAME);

		if ($this->isColumnModified(ElementFeedbackPeer::ID)) $criteria->add(ElementFeedbackPeer::ID, $this->id);
		if ($this->isColumnModified(ElementFeedbackPeer::DESCRIPTION)) $criteria->add(ElementFeedbackPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(ElementFeedbackPeer::QUANTITY)) $criteria->add(ElementFeedbackPeer::QUANTITY, $this->quantity);
		if ($this->isColumnModified(ElementFeedbackPeer::FEEDBACK_TYPE_ID)) $criteria->add(ElementFeedbackPeer::FEEDBACK_TYPE_ID, $this->feedback_type_id);
		if ($this->isColumnModified(ElementFeedbackPeer::UNIT_ID)) $criteria->add(ElementFeedbackPeer::UNIT_ID, $this->unit_id);
		if ($this->isColumnModified(ElementFeedbackPeer::SESSION_ELEMENT_ID)) $criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->session_element_id);
		if ($this->isColumnModified(ElementFeedbackPeer::PENDING)) $criteria->add(ElementFeedbackPeer::PENDING, $this->pending);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ElementFeedbackPeer::DATABASE_NAME);

		$criteria->add(ElementFeedbackPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setQuantity($this->quantity);

		$copyObj->setFeedbackTypeId($this->feedback_type_id);

		$copyObj->setUnitId($this->unit_id);

		$copyObj->setSessionElementId($this->session_element_id);

		$copyObj->setPending($this->pending);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ElementFeedbackPeer();
		}
		return self::$peer;
	}

	
	public function setFeedbackType($v)
	{


		if ($v === null) {
			$this->setFeedbackTypeId(NULL);
		} else {
			$this->setFeedbackTypeId($v->getId());
		}


		$this->aFeedbackType = $v;
	}


	
	public function getFeedbackType($con = null)
	{
		if ($this->aFeedbackType === null && ($this->feedback_type_id !== null)) {
						include_once 'lib/model/om/BaseFeedbackTypePeer.php';

			$this->aFeedbackType = FeedbackTypePeer::retrieveByPK($this->feedback_type_id, $con);

			
		}
		return $this->aFeedbackType;
	}

	
	public function setUnit($v)
	{


		if ($v === null) {
			$this->setUnitId(NULL);
		} else {
			$this->setUnitId($v->getId());
		}


		$this->aUnit = $v;
	}


	
	public function getUnit($con = null)
	{
		if ($this->aUnit === null && ($this->unit_id !== null)) {
						include_once 'lib/model/om/BaseUnitPeer.php';

			$this->aUnit = UnitPeer::retrieveByPK($this->unit_id, $con);

			
		}
		return $this->aUnit;
	}

	
	public function setSessionElement($v)
	{


		if ($v === null) {
			$this->setSessionElementId(NULL);
		} else {
			$this->setSessionElementId($v->getId());
		}


		$this->aSessionElement = $v;
	}


	
	public function getSessionElement($con = null)
	{
		if ($this->aSessionElement === null && ($this->session_element_id !== null)) {
						include_once 'lib/model/om/BaseSessionElementPeer.php';

			$this->aSessionElement = SessionElementPeer::retrieveByPK($this->session_element_id, $con);

			
		}
		return $this->aSessionElement;
	}

} 