<?php


abstract class BaseFeedback extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $quantity;


	
	protected $unit_id;


	
	protected $session_id;

	
	protected $aUnit;

	
	protected $aSession;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getQuantity()
	{

		return $this->quantity;
	}

	
	public function getUnitId()
	{

		return $this->unit_id;
	}

	
	public function getSessionId()
	{

		return $this->session_id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FeedbackPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = FeedbackPeer::DESCRIPTION;
		}

	} 
	
	public function setQuantity($v)
	{

		if ($this->quantity !== $v) {
			$this->quantity = $v;
			$this->modifiedColumns[] = FeedbackPeer::QUANTITY;
		}

	} 
	
	public function setUnitId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->unit_id !== $v) {
			$this->unit_id = $v;
			$this->modifiedColumns[] = FeedbackPeer::UNIT_ID;
		}

		if ($this->aUnit !== null && $this->aUnit->getId() !== $v) {
			$this->aUnit = null;
		}

	} 
	
	public function setSessionId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->session_id !== $v) {
			$this->session_id = $v;
			$this->modifiedColumns[] = FeedbackPeer::SESSION_ID;
		}

		if ($this->aSession !== null && $this->aSession->getId() !== $v) {
			$this->aSession = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->quantity = $rs->getFloat($startcol + 2);

			$this->unit_id = $rs->getInt($startcol + 3);

			$this->session_id = $rs->getInt($startcol + 4);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Feedback object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedbackPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FeedbackPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FeedbackPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUnit !== null) {
				if ($this->aUnit->isModified() || $this->aUnit->getCurrentUnitI18N()->isModified()) {
					$affectedRows += $this->aUnit->save($con);
				}
				$this->setUnit($this->aUnit);
			}

			if ($this->aSession !== null) {
				if ($this->aSession->isModified()) {
					$affectedRows += $this->aSession->save($con);
				}
				$this->setSession($this->aSession);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FeedbackPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += FeedbackPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUnit !== null) {
				if (!$this->aUnit->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnit->getValidationFailures());
				}
			}

			if ($this->aSession !== null) {
				if (!$this->aSession->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSession->getValidationFailures());
				}
			}


			if (($retval = FeedbackPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedbackPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getQuantity();
				break;
			case 3:
				return $this->getUnitId();
				break;
			case 4:
				return $this->getSessionId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedbackPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getQuantity(),
			$keys[3] => $this->getUnitId(),
			$keys[4] => $this->getSessionId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FeedbackPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setQuantity($value);
				break;
			case 3:
				$this->setUnitId($value);
				break;
			case 4:
				$this->setSessionId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FeedbackPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setQuantity($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setUnitId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setSessionId($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FeedbackPeer::DATABASE_NAME);

		if ($this->isColumnModified(FeedbackPeer::ID)) $criteria->add(FeedbackPeer::ID, $this->id);
		if ($this->isColumnModified(FeedbackPeer::DESCRIPTION)) $criteria->add(FeedbackPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(FeedbackPeer::QUANTITY)) $criteria->add(FeedbackPeer::QUANTITY, $this->quantity);
		if ($this->isColumnModified(FeedbackPeer::UNIT_ID)) $criteria->add(FeedbackPeer::UNIT_ID, $this->unit_id);
		if ($this->isColumnModified(FeedbackPeer::SESSION_ID)) $criteria->add(FeedbackPeer::SESSION_ID, $this->session_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FeedbackPeer::DATABASE_NAME);

		$criteria->add(FeedbackPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setQuantity($this->quantity);

		$copyObj->setUnitId($this->unit_id);

		$copyObj->setSessionId($this->session_id);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FeedbackPeer();
		}
		return self::$peer;
	}

	
	public function setUnit($v)
	{


		if ($v === null) {
			$this->setUnitId(NULL);
		} else {
			$this->setUnitId($v->getId());
		}


		$this->aUnit = $v;
	}


	
	public function getUnit($con = null)
	{
		if ($this->aUnit === null && ($this->unit_id !== null)) {
						include_once 'lib/model/om/BaseUnitPeer.php';

			$this->aUnit = UnitPeer::retrieveByPK($this->unit_id, $con);

			
		}
		return $this->aUnit;
	}

	
	public function setSession($v)
	{


		if ($v === null) {
			$this->setSessionId(NULL);
		} else {
			$this->setSessionId($v->getId());
		}


		$this->aSession = $v;
	}


	
	public function getSession($con = null)
	{
		if ($this->aSession === null && ($this->session_id !== null)) {
						include_once 'lib/model/om/BaseSessionPeer.php';

			$this->aSession = SessionPeer::retrieveByPK($this->session_id, $con);

			
		}
		return $this->aSession;
	}

} 