<?php


abstract class BaseMacrocycle extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $start_at;


	
	protected $last_day_at;


	
	protected $season_id;


	
	protected $theoric_intensity;


	
	protected $theoric_volume;


	
	protected $reported_intensity;


	
	protected $reported_volume;

	
	protected $aSeason;

	
	protected $collMesocycles;

	
	protected $lastMesocycleCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getStartAt($format = 'Y-m-d')
	{

		if ($this->start_at === null || $this->start_at === '') {
			return null;
		} elseif (!is_int($this->start_at)) {
						$ts = strtotime($this->start_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [start_at] as date/time value: " . var_export($this->start_at, true));
			}
		} else {
			$ts = $this->start_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getLastDayAt($format = 'Y-m-d')
	{

		if ($this->last_day_at === null || $this->last_day_at === '') {
			return null;
		} elseif (!is_int($this->last_day_at)) {
						$ts = strtotime($this->last_day_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [last_day_at] as date/time value: " . var_export($this->last_day_at, true));
			}
		} else {
			$ts = $this->last_day_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getSeasonId()
	{

		return $this->season_id;
	}

	
	public function getTheoricIntensity()
	{

		return $this->theoric_intensity;
	}

	
	public function getTheoricVolume()
	{

		return $this->theoric_volume;
	}

	
	public function getReportedIntensity()
	{

		return $this->reported_intensity;
	}

	
	public function getReportedVolume()
	{

		return $this->reported_volume;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = MacrocyclePeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = MacrocyclePeer::DESCRIPTION;
		}

	} 
	
	public function setStartAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [start_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->start_at !== $ts) {
			$this->start_at = $ts;
			$this->modifiedColumns[] = MacrocyclePeer::START_AT;
		}

	} 
	
	public function setLastDayAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [last_day_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_day_at !== $ts) {
			$this->last_day_at = $ts;
			$this->modifiedColumns[] = MacrocyclePeer::LAST_DAY_AT;
		}

	} 
	
	public function setSeasonId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->season_id !== $v) {
			$this->season_id = $v;
			$this->modifiedColumns[] = MacrocyclePeer::SEASON_ID;
		}

		if ($this->aSeason !== null && $this->aSeason->getId() !== $v) {
			$this->aSeason = null;
		}

	} 
	
	public function setTheoricIntensity($v)
	{

		if ($this->theoric_intensity !== $v) {
			$this->theoric_intensity = $v;
			$this->modifiedColumns[] = MacrocyclePeer::THEORIC_INTENSITY;
		}

	} 
	
	public function setTheoricVolume($v)
	{

		if ($this->theoric_volume !== $v) {
			$this->theoric_volume = $v;
			$this->modifiedColumns[] = MacrocyclePeer::THEORIC_VOLUME;
		}

	} 
	
	public function setReportedIntensity($v)
	{

		if ($this->reported_intensity !== $v) {
			$this->reported_intensity = $v;
			$this->modifiedColumns[] = MacrocyclePeer::REPORTED_INTENSITY;
		}

	} 
	
	public function setReportedVolume($v)
	{

		if ($this->reported_volume !== $v) {
			$this->reported_volume = $v;
			$this->modifiedColumns[] = MacrocyclePeer::REPORTED_VOLUME;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->start_at = $rs->getDate($startcol + 2, null);

			$this->last_day_at = $rs->getDate($startcol + 3, null);

			$this->season_id = $rs->getInt($startcol + 4);

			$this->theoric_intensity = $rs->getFloat($startcol + 5);

			$this->theoric_volume = $rs->getFloat($startcol + 6);

			$this->reported_intensity = $rs->getFloat($startcol + 7);

			$this->reported_volume = $rs->getFloat($startcol + 8);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 9; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Macrocycle object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MacrocyclePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			MacrocyclePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(MacrocyclePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aSeason !== null) {
				if ($this->aSeason->isModified()) {
					$affectedRows += $this->aSeason->save($con);
				}
				$this->setSeason($this->aSeason);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MacrocyclePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += MacrocyclePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collMesocycles !== null) {
				foreach($this->collMesocycles as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aSeason !== null) {
				if (!$this->aSeason->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSeason->getValidationFailures());
				}
			}


			if (($retval = MacrocyclePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collMesocycles !== null) {
					foreach($this->collMesocycles as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MacrocyclePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getStartAt();
				break;
			case 3:
				return $this->getLastDayAt();
				break;
			case 4:
				return $this->getSeasonId();
				break;
			case 5:
				return $this->getTheoricIntensity();
				break;
			case 6:
				return $this->getTheoricVolume();
				break;
			case 7:
				return $this->getReportedIntensity();
				break;
			case 8:
				return $this->getReportedVolume();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = MacrocyclePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getStartAt(),
			$keys[3] => $this->getLastDayAt(),
			$keys[4] => $this->getSeasonId(),
			$keys[5] => $this->getTheoricIntensity(),
			$keys[6] => $this->getTheoricVolume(),
			$keys[7] => $this->getReportedIntensity(),
			$keys[8] => $this->getReportedVolume(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = MacrocyclePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setStartAt($value);
				break;
			case 3:
				$this->setLastDayAt($value);
				break;
			case 4:
				$this->setSeasonId($value);
				break;
			case 5:
				$this->setTheoricIntensity($value);
				break;
			case 6:
				$this->setTheoricVolume($value);
				break;
			case 7:
				$this->setReportedIntensity($value);
				break;
			case 8:
				$this->setReportedVolume($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = MacrocyclePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setStartAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLastDayAt($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setSeasonId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTheoricIntensity($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTheoricVolume($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setReportedIntensity($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setReportedVolume($arr[$keys[8]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(MacrocyclePeer::DATABASE_NAME);

		if ($this->isColumnModified(MacrocyclePeer::ID)) $criteria->add(MacrocyclePeer::ID, $this->id);
		if ($this->isColumnModified(MacrocyclePeer::DESCRIPTION)) $criteria->add(MacrocyclePeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(MacrocyclePeer::START_AT)) $criteria->add(MacrocyclePeer::START_AT, $this->start_at);
		if ($this->isColumnModified(MacrocyclePeer::LAST_DAY_AT)) $criteria->add(MacrocyclePeer::LAST_DAY_AT, $this->last_day_at);
		if ($this->isColumnModified(MacrocyclePeer::SEASON_ID)) $criteria->add(MacrocyclePeer::SEASON_ID, $this->season_id);
		if ($this->isColumnModified(MacrocyclePeer::THEORIC_INTENSITY)) $criteria->add(MacrocyclePeer::THEORIC_INTENSITY, $this->theoric_intensity);
		if ($this->isColumnModified(MacrocyclePeer::THEORIC_VOLUME)) $criteria->add(MacrocyclePeer::THEORIC_VOLUME, $this->theoric_volume);
		if ($this->isColumnModified(MacrocyclePeer::REPORTED_INTENSITY)) $criteria->add(MacrocyclePeer::REPORTED_INTENSITY, $this->reported_intensity);
		if ($this->isColumnModified(MacrocyclePeer::REPORTED_VOLUME)) $criteria->add(MacrocyclePeer::REPORTED_VOLUME, $this->reported_volume);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(MacrocyclePeer::DATABASE_NAME);

		$criteria->add(MacrocyclePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setStartAt($this->start_at);

		$copyObj->setLastDayAt($this->last_day_at);

		$copyObj->setSeasonId($this->season_id);

		$copyObj->setTheoricIntensity($this->theoric_intensity);

		$copyObj->setTheoricVolume($this->theoric_volume);

		$copyObj->setReportedIntensity($this->reported_intensity);

		$copyObj->setReportedVolume($this->reported_volume);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getMesocycles() as $relObj) {
				$copyObj->addMesocycle($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MacrocyclePeer();
		}
		return self::$peer;
	}

	
	public function setSeason($v)
	{


		if ($v === null) {
			$this->setSeasonId(NULL);
		} else {
			$this->setSeasonId($v->getId());
		}


		$this->aSeason = $v;
	}


	
	public function getSeason($con = null)
	{
		if ($this->aSeason === null && ($this->season_id !== null)) {
						include_once 'lib/model/om/BaseSeasonPeer.php';

			$this->aSeason = SeasonPeer::retrieveByPK($this->season_id, $con);

			
		}
		return $this->aSeason;
	}

	
	public function initMesocycles()
	{
		if ($this->collMesocycles === null) {
			$this->collMesocycles = array();
		}
	}

	
	public function getMesocycles($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseMesocyclePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMesocycles === null) {
			if ($this->isNew()) {
			   $this->collMesocycles = array();
			} else {

				$criteria->add(MesocyclePeer::MACROCYCLE_ID, $this->getId());

				MesocyclePeer::addSelectColumns($criteria);
				$this->collMesocycles = MesocyclePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MesocyclePeer::MACROCYCLE_ID, $this->getId());

				MesocyclePeer::addSelectColumns($criteria);
				if (!isset($this->lastMesocycleCriteria) || !$this->lastMesocycleCriteria->equals($criteria)) {
					$this->collMesocycles = MesocyclePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMesocycleCriteria = $criteria;
		return $this->collMesocycles;
	}

	
	public function countMesocycles($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseMesocyclePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(MesocyclePeer::MACROCYCLE_ID, $this->getId());

		return MesocyclePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addMesocycle(Mesocycle $l)
	{
		$this->collMesocycles[] = $l;
		$l->setMacrocycle($this);
	}

} 