<?php


abstract class BasePrice extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $amount1;


	
	protected $init1_at;


	
	protected $amount2;


	
	protected $init2_at;

	
	protected $collCategorys;

	
	protected $lastCategoryCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getAmount1()
	{

		return $this->amount1;
	}

	
	public function getInit1At($format = 'Y-m-d')
	{

		if ($this->init1_at === null || $this->init1_at === '') {
			return null;
		} elseif (!is_int($this->init1_at)) {
						$ts = strtotime($this->init1_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [init1_at] as date/time value: " . var_export($this->init1_at, true));
			}
		} else {
			$ts = $this->init1_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getAmount2()
	{

		return $this->amount2;
	}

	
	public function getInit2At($format = 'Y-m-d')
	{

		if ($this->init2_at === null || $this->init2_at === '') {
			return null;
		} elseif (!is_int($this->init2_at)) {
						$ts = strtotime($this->init2_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [init2_at] as date/time value: " . var_export($this->init2_at, true));
			}
		} else {
			$ts = $this->init2_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PricePeer::ID;
		}

	} 
	
	public function setAmount1($v)
	{

		if ($this->amount1 !== $v) {
			$this->amount1 = $v;
			$this->modifiedColumns[] = PricePeer::AMOUNT1;
		}

	} 
	
	public function setInit1At($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [init1_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->init1_at !== $ts) {
			$this->init1_at = $ts;
			$this->modifiedColumns[] = PricePeer::INIT1_AT;
		}

	} 
	
	public function setAmount2($v)
	{

		if ($this->amount2 !== $v) {
			$this->amount2 = $v;
			$this->modifiedColumns[] = PricePeer::AMOUNT2;
		}

	} 
	
	public function setInit2At($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [init2_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->init2_at !== $ts) {
			$this->init2_at = $ts;
			$this->modifiedColumns[] = PricePeer::INIT2_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->amount1 = $rs->getFloat($startcol + 1);

			$this->init1_at = $rs->getDate($startcol + 2, null);

			$this->amount2 = $rs->getFloat($startcol + 3);

			$this->init2_at = $rs->getDate($startcol + 4, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Price object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PricePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PricePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PricePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PricePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += PricePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collCategorys !== null) {
				foreach($this->collCategorys as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = PricePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCategorys !== null) {
					foreach($this->collCategorys as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PricePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getAmount1();
				break;
			case 2:
				return $this->getInit1At();
				break;
			case 3:
				return $this->getAmount2();
				break;
			case 4:
				return $this->getInit2At();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PricePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getAmount1(),
			$keys[2] => $this->getInit1At(),
			$keys[3] => $this->getAmount2(),
			$keys[4] => $this->getInit2At(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PricePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setAmount1($value);
				break;
			case 2:
				$this->setInit1At($value);
				break;
			case 3:
				$this->setAmount2($value);
				break;
			case 4:
				$this->setInit2At($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PricePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setAmount1($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setInit1At($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setAmount2($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setInit2At($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(PricePeer::DATABASE_NAME);

		if ($this->isColumnModified(PricePeer::ID)) $criteria->add(PricePeer::ID, $this->id);
		if ($this->isColumnModified(PricePeer::AMOUNT1)) $criteria->add(PricePeer::AMOUNT1, $this->amount1);
		if ($this->isColumnModified(PricePeer::INIT1_AT)) $criteria->add(PricePeer::INIT1_AT, $this->init1_at);
		if ($this->isColumnModified(PricePeer::AMOUNT2)) $criteria->add(PricePeer::AMOUNT2, $this->amount2);
		if ($this->isColumnModified(PricePeer::INIT2_AT)) $criteria->add(PricePeer::INIT2_AT, $this->init2_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PricePeer::DATABASE_NAME);

		$criteria->add(PricePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setAmount1($this->amount1);

		$copyObj->setInit1At($this->init1_at);

		$copyObj->setAmount2($this->amount2);

		$copyObj->setInit2At($this->init2_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getCategorys() as $relObj) {
				$copyObj->addCategory($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PricePeer();
		}
		return self::$peer;
	}

	
	public function initCategorys()
	{
		if ($this->collCategorys === null) {
			$this->collCategorys = array();
		}
	}

	
	public function getCategorys($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
			   $this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

				CategoryPeer::addSelectColumns($criteria);
				$this->collCategorys = CategoryPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

				CategoryPeer::addSelectColumns($criteria);
				if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
					$this->collCategorys = CategoryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCategoryCriteria = $criteria;
		return $this->collCategorys;
	}

	
	public function countCategorys($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

		return CategoryPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCategory(Category $l)
	{
		$this->collCategorys[] = $l;
		$l->setPrice($this);
	}


	
	public function getCategorysJoinEvent($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
				$this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

				$this->collCategorys = CategoryPeer::doSelectJoinEvent($criteria, $con);
			}
		} else {
									
			$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

			if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
				$this->collCategorys = CategoryPeer::doSelectJoinEvent($criteria, $con);
			}
		}
		$this->lastCategoryCriteria = $criteria;

		return $this->collCategorys;
	}


	
	public function getCategorysJoinCircuit($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCategorys === null) {
			if ($this->isNew()) {
				$this->collCategorys = array();
			} else {

				$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

				$this->collCategorys = CategoryPeer::doSelectJoinCircuit($criteria, $con);
			}
		} else {
									
			$criteria->add(CategoryPeer::PRICE_ID, $this->getId());

			if (!isset($this->lastCategoryCriteria) || !$this->lastCategoryCriteria->equals($criteria)) {
				$this->collCategorys = CategoryPeer::doSelectJoinCircuit($criteria, $con);
			}
		}
		$this->lastCategoryCriteria = $criteria;

		return $this->collCategorys;
	}

} 