<?php


abstract class BaseSessionElement extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $level;


	
	protected $working_method_id;


	
	protected $session_id;


	
	protected $theoric_intensity;


	
	protected $theoric_volume;


	
	protected $reported_intensity;


	
	protected $reported_volume;

	
	protected $aWorkingMethod;

	
	protected $aSession;

	
	protected $collElementFeedbacks;

	
	protected $lastElementFeedbackCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getLevel()
	{

		return $this->level;
	}

	
	public function getWorkingMethodId()
	{

		return $this->working_method_id;
	}

	
	public function getSessionId()
	{

		return $this->session_id;
	}

	
	public function getTheoricIntensity()
	{

		return $this->theoric_intensity;
	}

	
	public function getTheoricVolume()
	{

		return $this->theoric_volume;
	}

	
	public function getReportedIntensity()
	{

		return $this->reported_intensity;
	}

	
	public function getReportedVolume()
	{

		return $this->reported_volume;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SessionElementPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = SessionElementPeer::DESCRIPTION;
		}

	} 
	
	public function setLevel($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->level !== $v) {
			$this->level = $v;
			$this->modifiedColumns[] = SessionElementPeer::LEVEL;
		}

	} 
	
	public function setWorkingMethodId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->working_method_id !== $v) {
			$this->working_method_id = $v;
			$this->modifiedColumns[] = SessionElementPeer::WORKING_METHOD_ID;
		}

		if ($this->aWorkingMethod !== null && $this->aWorkingMethod->getId() !== $v) {
			$this->aWorkingMethod = null;
		}

	} 
	
	public function setSessionId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->session_id !== $v) {
			$this->session_id = $v;
			$this->modifiedColumns[] = SessionElementPeer::SESSION_ID;
		}

		if ($this->aSession !== null && $this->aSession->getId() !== $v) {
			$this->aSession = null;
		}

	} 
	
	public function setTheoricIntensity($v)
	{

		if ($this->theoric_intensity !== $v) {
			$this->theoric_intensity = $v;
			$this->modifiedColumns[] = SessionElementPeer::THEORIC_INTENSITY;
		}

	} 
	
	public function setTheoricVolume($v)
	{

		if ($this->theoric_volume !== $v) {
			$this->theoric_volume = $v;
			$this->modifiedColumns[] = SessionElementPeer::THEORIC_VOLUME;
		}

	} 
	
	public function setReportedIntensity($v)
	{

		if ($this->reported_intensity !== $v) {
			$this->reported_intensity = $v;
			$this->modifiedColumns[] = SessionElementPeer::REPORTED_INTENSITY;
		}

	} 
	
	public function setReportedVolume($v)
	{

		if ($this->reported_volume !== $v) {
			$this->reported_volume = $v;
			$this->modifiedColumns[] = SessionElementPeer::REPORTED_VOLUME;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->level = $rs->getInt($startcol + 2);

			$this->working_method_id = $rs->getInt($startcol + 3);

			$this->session_id = $rs->getInt($startcol + 4);

			$this->theoric_intensity = $rs->getFloat($startcol + 5);

			$this->theoric_volume = $rs->getFloat($startcol + 6);

			$this->reported_intensity = $rs->getFloat($startcol + 7);

			$this->reported_volume = $rs->getFloat($startcol + 8);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 9; 
		} catch (Exception $e) {
			throw new PropelException("Error populating SessionElement object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionElementPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SessionElementPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionElementPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aWorkingMethod !== null) {
				if ($this->aWorkingMethod->isModified()) {
					$affectedRows += $this->aWorkingMethod->save($con);
				}
				$this->setWorkingMethod($this->aWorkingMethod);
			}

			if ($this->aSession !== null) {
				if ($this->aSession->isModified()) {
					$affectedRows += $this->aSession->save($con);
				}
				$this->setSession($this->aSession);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SessionElementPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SessionElementPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collElementFeedbacks !== null) {
				foreach($this->collElementFeedbacks as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aWorkingMethod !== null) {
				if (!$this->aWorkingMethod->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aWorkingMethod->getValidationFailures());
				}
			}

			if ($this->aSession !== null) {
				if (!$this->aSession->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSession->getValidationFailures());
				}
			}


			if (($retval = SessionElementPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collElementFeedbacks !== null) {
					foreach($this->collElementFeedbacks as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionElementPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getLevel();
				break;
			case 3:
				return $this->getWorkingMethodId();
				break;
			case 4:
				return $this->getSessionId();
				break;
			case 5:
				return $this->getTheoricIntensity();
				break;
			case 6:
				return $this->getTheoricVolume();
				break;
			case 7:
				return $this->getReportedIntensity();
				break;
			case 8:
				return $this->getReportedVolume();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionElementPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getLevel(),
			$keys[3] => $this->getWorkingMethodId(),
			$keys[4] => $this->getSessionId(),
			$keys[5] => $this->getTheoricIntensity(),
			$keys[6] => $this->getTheoricVolume(),
			$keys[7] => $this->getReportedIntensity(),
			$keys[8] => $this->getReportedVolume(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionElementPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setLevel($value);
				break;
			case 3:
				$this->setWorkingMethodId($value);
				break;
			case 4:
				$this->setSessionId($value);
				break;
			case 5:
				$this->setTheoricIntensity($value);
				break;
			case 6:
				$this->setTheoricVolume($value);
				break;
			case 7:
				$this->setReportedIntensity($value);
				break;
			case 8:
				$this->setReportedVolume($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionElementPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setLevel($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setWorkingMethodId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setSessionId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTheoricIntensity($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTheoricVolume($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setReportedIntensity($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setReportedVolume($arr[$keys[8]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SessionElementPeer::DATABASE_NAME);

		if ($this->isColumnModified(SessionElementPeer::ID)) $criteria->add(SessionElementPeer::ID, $this->id);
		if ($this->isColumnModified(SessionElementPeer::DESCRIPTION)) $criteria->add(SessionElementPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(SessionElementPeer::LEVEL)) $criteria->add(SessionElementPeer::LEVEL, $this->level);
		if ($this->isColumnModified(SessionElementPeer::WORKING_METHOD_ID)) $criteria->add(SessionElementPeer::WORKING_METHOD_ID, $this->working_method_id);
		if ($this->isColumnModified(SessionElementPeer::SESSION_ID)) $criteria->add(SessionElementPeer::SESSION_ID, $this->session_id);
		if ($this->isColumnModified(SessionElementPeer::THEORIC_INTENSITY)) $criteria->add(SessionElementPeer::THEORIC_INTENSITY, $this->theoric_intensity);
		if ($this->isColumnModified(SessionElementPeer::THEORIC_VOLUME)) $criteria->add(SessionElementPeer::THEORIC_VOLUME, $this->theoric_volume);
		if ($this->isColumnModified(SessionElementPeer::REPORTED_INTENSITY)) $criteria->add(SessionElementPeer::REPORTED_INTENSITY, $this->reported_intensity);
		if ($this->isColumnModified(SessionElementPeer::REPORTED_VOLUME)) $criteria->add(SessionElementPeer::REPORTED_VOLUME, $this->reported_volume);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SessionElementPeer::DATABASE_NAME);

		$criteria->add(SessionElementPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setLevel($this->level);

		$copyObj->setWorkingMethodId($this->working_method_id);

		$copyObj->setSessionId($this->session_id);

		$copyObj->setTheoricIntensity($this->theoric_intensity);

		$copyObj->setTheoricVolume($this->theoric_volume);

		$copyObj->setReportedIntensity($this->reported_intensity);

		$copyObj->setReportedVolume($this->reported_volume);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getElementFeedbacks() as $relObj) {
				$copyObj->addElementFeedback($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SessionElementPeer();
		}
		return self::$peer;
	}

	
	public function setWorkingMethod($v)
	{


		if ($v === null) {
			$this->setWorkingMethodId(NULL);
		} else {
			$this->setWorkingMethodId($v->getId());
		}


		$this->aWorkingMethod = $v;
	}


	
	public function getWorkingMethod($con = null)
	{
		if ($this->aWorkingMethod === null && ($this->working_method_id !== null)) {
						include_once 'lib/model/om/BaseWorkingMethodPeer.php';

			$this->aWorkingMethod = WorkingMethodPeer::retrieveByPK($this->working_method_id, $con);

			
		}
		return $this->aWorkingMethod;
	}

	
	public function setSession($v)
	{


		if ($v === null) {
			$this->setSessionId(NULL);
		} else {
			$this->setSessionId($v->getId());
		}


		$this->aSession = $v;
	}


	
	public function getSession($con = null)
	{
		if ($this->aSession === null && ($this->session_id !== null)) {
						include_once 'lib/model/om/BaseSessionPeer.php';

			$this->aSession = SessionPeer::retrieveByPK($this->session_id, $con);

			
		}
		return $this->aSession;
	}

	
	public function initElementFeedbacks()
	{
		if ($this->collElementFeedbacks === null) {
			$this->collElementFeedbacks = array();
		}
	}

	
	public function getElementFeedbacks($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collElementFeedbacks === null) {
			if ($this->isNew()) {
			   $this->collElementFeedbacks = array();
			} else {

				$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

				ElementFeedbackPeer::addSelectColumns($criteria);
				$this->collElementFeedbacks = ElementFeedbackPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

				ElementFeedbackPeer::addSelectColumns($criteria);
				if (!isset($this->lastElementFeedbackCriteria) || !$this->lastElementFeedbackCriteria->equals($criteria)) {
					$this->collElementFeedbacks = ElementFeedbackPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastElementFeedbackCriteria = $criteria;
		return $this->collElementFeedbacks;
	}

	
	public function countElementFeedbacks($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

		return ElementFeedbackPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addElementFeedback(ElementFeedback $l)
	{
		$this->collElementFeedbacks[] = $l;
		$l->setSessionElement($this);
	}


	
	public function getElementFeedbacksJoinFeedbackType($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collElementFeedbacks === null) {
			if ($this->isNew()) {
				$this->collElementFeedbacks = array();
			} else {

				$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinFeedbackType($criteria, $con);
			}
		} else {
									
			$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

			if (!isset($this->lastElementFeedbackCriteria) || !$this->lastElementFeedbackCriteria->equals($criteria)) {
				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinFeedbackType($criteria, $con);
			}
		}
		$this->lastElementFeedbackCriteria = $criteria;

		return $this->collElementFeedbacks;
	}


	
	public function getElementFeedbacksJoinUnit($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseElementFeedbackPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collElementFeedbacks === null) {
			if ($this->isNew()) {
				$this->collElementFeedbacks = array();
			} else {

				$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinUnit($criteria, $con);
			}
		} else {
									
			$criteria->add(ElementFeedbackPeer::SESSION_ELEMENT_ID, $this->getId());

			if (!isset($this->lastElementFeedbackCriteria) || !$this->lastElementFeedbackCriteria->equals($criteria)) {
				$this->collElementFeedbacks = ElementFeedbackPeer::doSelectJoinUnit($criteria, $con);
			}
		}
		$this->lastElementFeedbackCriteria = $criteria;

		return $this->collElementFeedbacks;
	}

} 