<?php


abstract class BaseSize extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $summary;

	
	protected $collRunners;

	
	protected $lastRunnerCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getSummary()
	{

		return $this->summary;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SizePeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = SizePeer::DESCRIPTION;
		}

	} 
	
	public function setSummary($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->summary !== $v) {
			$this->summary = $v;
			$this->modifiedColumns[] = SizePeer::SUMMARY;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->summary = $rs->getString($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Size object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SizePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SizePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SizePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SizePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SizePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collRunners !== null) {
				foreach($this->collRunners as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = SizePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collRunners !== null) {
					foreach($this->collRunners as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SizePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getSummary();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SizePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getSummary(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SizePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setSummary($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SizePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setSummary($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SizePeer::DATABASE_NAME);

		if ($this->isColumnModified(SizePeer::ID)) $criteria->add(SizePeer::ID, $this->id);
		if ($this->isColumnModified(SizePeer::DESCRIPTION)) $criteria->add(SizePeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(SizePeer::SUMMARY)) $criteria->add(SizePeer::SUMMARY, $this->summary);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SizePeer::DATABASE_NAME);

		$criteria->add(SizePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setSummary($this->summary);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getRunners() as $relObj) {
				$copyObj->addRunner($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SizePeer();
		}
		return self::$peer;
	}

	
	public function initRunners()
	{
		if ($this->collRunners === null) {
			$this->collRunners = array();
		}
	}

	
	public function getRunners($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
			   $this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

				RunnerPeer::addSelectColumns($criteria);
				$this->collRunners = RunnerPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

				RunnerPeer::addSelectColumns($criteria);
				if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
					$this->collRunners = RunnerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRunnerCriteria = $criteria;
		return $this->collRunners;
	}

	
	public function countRunners($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

		return RunnerPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addRunner(Runner $l)
	{
		$this->collRunners[] = $l;
		$l->setSize($this);
	}


	
	public function getRunnersJoinInscription($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
				$this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

				$this->collRunners = RunnerPeer::doSelectJoinInscription($criteria, $con);
			}
		} else {
									
			$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

			if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
				$this->collRunners = RunnerPeer::doSelectJoinInscription($criteria, $con);
			}
		}
		$this->lastRunnerCriteria = $criteria;

		return $this->collRunners;
	}


	
	public function getRunnersJoinCategory($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
				$this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

				$this->collRunners = RunnerPeer::doSelectJoinCategory($criteria, $con);
			}
		} else {
									
			$criteria->add(RunnerPeer::SIZE_ID, $this->getId());

			if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
				$this->collRunners = RunnerPeer::doSelectJoinCategory($criteria, $con);
			}
		}
		$this->lastRunnerCriteria = $criteria;

		return $this->collRunners;
	}

} 