<?php


abstract class BaseWorkingMethod extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;

	
	protected $collSessionElements;

	
	protected $lastSessionElementCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = WorkingMethodPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = WorkingMethodPeer::DESCRIPTION;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating WorkingMethod object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(WorkingMethodPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			WorkingMethodPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(WorkingMethodPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = WorkingMethodPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += WorkingMethodPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collSessionElements !== null) {
				foreach($this->collSessionElements as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = WorkingMethodPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collSessionElements !== null) {
					foreach($this->collSessionElements as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = WorkingMethodPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = WorkingMethodPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = WorkingMethodPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = WorkingMethodPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(WorkingMethodPeer::DATABASE_NAME);

		if ($this->isColumnModified(WorkingMethodPeer::ID)) $criteria->add(WorkingMethodPeer::ID, $this->id);
		if ($this->isColumnModified(WorkingMethodPeer::DESCRIPTION)) $criteria->add(WorkingMethodPeer::DESCRIPTION, $this->description);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(WorkingMethodPeer::DATABASE_NAME);

		$criteria->add(WorkingMethodPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getSessionElements() as $relObj) {
				$copyObj->addSessionElement($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new WorkingMethodPeer();
		}
		return self::$peer;
	}

	
	public function initSessionElements()
	{
		if ($this->collSessionElements === null) {
			$this->collSessionElements = array();
		}
	}

	
	public function getSessionElements($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSessionElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessionElements === null) {
			if ($this->isNew()) {
			   $this->collSessionElements = array();
			} else {

				$criteria->add(SessionElementPeer::WORKING_METHOD_ID, $this->getId());

				SessionElementPeer::addSelectColumns($criteria);
				$this->collSessionElements = SessionElementPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SessionElementPeer::WORKING_METHOD_ID, $this->getId());

				SessionElementPeer::addSelectColumns($criteria);
				if (!isset($this->lastSessionElementCriteria) || !$this->lastSessionElementCriteria->equals($criteria)) {
					$this->collSessionElements = SessionElementPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSessionElementCriteria = $criteria;
		return $this->collSessionElements;
	}

	
	public function countSessionElements($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseSessionElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SessionElementPeer::WORKING_METHOD_ID, $this->getId());

		return SessionElementPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addSessionElement(SessionElement $l)
	{
		$this->collSessionElements[] = $l;
		$l->setWorkingMethod($this);
	}


	
	public function getSessionElementsJoinSession($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSessionElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSessionElements === null) {
			if ($this->isNew()) {
				$this->collSessionElements = array();
			} else {

				$criteria->add(SessionElementPeer::WORKING_METHOD_ID, $this->getId());

				$this->collSessionElements = SessionElementPeer::doSelectJoinSession($criteria, $con);
			}
		} else {
									
			$criteria->add(SessionElementPeer::WORKING_METHOD_ID, $this->getId());

			if (!isset($this->lastSessionElementCriteria) || !$this->lastSessionElementCriteria->equals($criteria)) {
				$this->collSessionElements = SessionElementPeer::doSelectJoinSession($criteria, $con);
			}
		}
		$this->lastSessionElementCriteria = $criteria;

		return $this->collSessionElements;
	}

} 